#include "Konstanten.h"

#include <wx/notebook.h>

BEGIN_EVENT_TABLE(Auswahl, wxFrame)
    EVT_BUTTON(ID_OrdnerAuswahl1, Auswahl::OrdnerAuswahl1)
    EVT_BUTTON(ID_OrdnerAuswahl2, Auswahl::OrdnerAuswahl2)
    EVT_BUTTON(ID_OrdnerAuswahl3, Auswahl::OrdnerAuswahl3)
    EVT_BUTTON(ID_Ende, Hauptfenster::Ende)
    EVT_BUTTON(ID_Starten, Auswahl::Starten)
    EVT_BUTTON(ID_SpeichernErstellen, Auswahl::SpeichernErstellen)
    EVT_BUTTON(ID_SpeichernAendern, Auswahl::SpeichernAendern)
END_EVENT_TABLE()

Auswahl::Auswahl(Wahl wahl, const wxString& Titel, const wxString& Pfad)
        : wxFrame(NULL, 0, Titel, wxPoint(60, 50), wxSize(450, 340),
                  wxCAPTION | wxFRAME_TOOL_WINDOW | wxCLOSE_BOX | wxFRAME_FLOAT_ON_PARENT)
{
    /* Weil in eigenen Funktionen nicht auf die
    ** Parameter des Fensters zugreifen können,
    ** werden sie in neue Variablen geschrieben
    */
    wahlbuf = wahl;
    Titelbuf = Titel.mb_str(wxConvUTF8);
    Pfadbuf = Pfad.mb_str();


    wxPanel *Panel = new wxPanel(this);
    Panel->SetBackgroundColour(wxColour(0, 255, 155));

    Text1 = new wxStaticText(Panel, wxID_ANY,
                             _("1. Ordner zum Synchronisieren"),wxPoint(20, 20));
    Text1->Show();

    Feld1 = new wxTextCtrl(Panel, -1, _(""), wxPoint(20, 50), wxSize(300, 30));
    Feld1->Show(true);

    Knopf1 = new wxButton(Panel, ID_OrdnerAuswahl1, _("..."),
                          wxPoint(325, 50), wxSize(25, 30));
    Knopf1->Show(true);

    Text2 = new wxStaticText(Panel, -1,
                             _("2. Ordner zum Synchronisieren"), wxPoint(20, 110));
    Text2->Show(true);

    Feld2 = new wxTextCtrl(Panel, -1, _(""), wxPoint(20, 140), wxSize(300, 30));
    Feld2->Show(true);

    Knopf2 = new wxButton(Panel, ID_OrdnerAuswahl2, _("..."),
                          wxPoint(325, 140), wxSize(25, 30));
    Knopf2->Show(true);

    Text3 = new wxStaticText(Panel, -1,
                             _("Dokumentation (optional)"), wxPoint(20, 200));
    Text3->Show(true);

    Feld3 = new wxTextCtrl(Panel, -1, _(""), wxPoint(20, 230), wxSize(300, 30));
    Feld3->Show(true);

    Knopf3 = new wxButton(Panel, ID_OrdnerAuswahl3, _("..."),
                          wxPoint(325, 230), wxSize(25, 30));
    Knopf3->Show(true);

    wxButton *Abbrechen = new wxButton(Panel, ID_Ende, _("Abbrechen"),
                                       wxPoint(20, 270));
    Abbrechen->Show(true);

    /* Hier werden der Text vom Startknopf
    ** und dessen Funktion abhängig vom
    ** Modus verändert
    */
    string Startknopf;
    int Funktion;
    switch(wahl)
    {
    case A_NachWahl:
        Startknopf="Starten";
        Funktion=ID_Starten;
        break;

    case A_Eigene:
        Startknopf="Starten";
        Funktion=ID_Starten;
        DatenSchreiben();
        break;

    case A_Erstellen:
        Startknopf="Speichern";
        Funktion=ID_SpeichernErstellen;
        break;

    case A_Aendern:
        Startknopf="Speichern";
        Funktion=ID_SpeichernAendern;
        DatenSchreiben();
        break;
    }
    wxButton *Starten = new wxButton(Panel, Funktion, wxString::FromUTF8(Startknopf.c_str()),
                                     wxPoint(250, 270));
    Starten->Show(true);
}

/* Diese Funktionen lassen den Nutzer
** Einen Ordner auswählen, dessen Pfad
** dann in das Textfeld geschrieben wird
*/
void Auswahl::OrdnerAuswahl1(wxCommandEvent& WXUNUSED(event))
{
    TextErsetzen(Feld1);
    Raise();
}

void Auswahl::OrdnerAuswahl2(wxCommandEvent& WXUNUSED(event))
{
    TextErsetzen(Feld2);
    Raise();
}

void Auswahl::OrdnerAuswahl3(wxCommandEvent& WXUNUSED(event))
{
    TextErsetzen(Feld3);
    Raise();
}

// Die Synchronisation wird gestartet
void Auswahl::Starten(wxCommandEvent& WXUNUSED(event))
{
    char c[512], d[512], e[512];
    const wxString& t1 = Feld1->GetLineText(0);
    const wxString& t2 = Feld2->GetLineText(0);
    const wxString& t3 = Feld3->GetLineText(0);
    strncpy(c, (const char*)t1.mb_str(wxConvUTF8), 511);
    strncpy(d, (const char*)t2.mb_str(wxConvUTF8), 511);
    strncpy(e, (const char*)t3.mb_str(wxConvUTF8), 511);

    if(Synchronisation(c, d, e))
        Close(true);
}

// Eine otto-Datei wird erstellt
void Auswahl::SpeichernErstellen(wxCommandEvent& WXUNUSED(event))
{
    const wxString& Ordner = wxDirSelector(_("Wo soll die Datei abgespeichert werden?"));
    if(!Ordner.empty())
    {
        const wxString& Name = wxGetTextFromUser(_("Name der Datei"));
        if(!Name.empty())
        {
            const wxString& Pfad = Ordner + wxString::FromUTF8(&Abtrenner) + Name + _(".otto");
            if(Speichern(Pfad))
                Close(true);
        }
    }
}

/* Eine otto-Datei wurde geändert und
** wird so abgespeichert
*/
void Auswahl::SpeichernAendern(wxCommandEvent& WXUNUSED(event))
{
    if(Speichern(wxString::FromUTF8(Pfadbuf.c_str())))
        Close(true);
}

/*Datei wird geöffnet und die zu speichernden
** Parameter reingeschrieben,
*/
bool Auswahl::Speichern(const wxString& Pfad)
{
    if(fopen(Pfad.mb_str(wxConvUTF8), "w"))
    {
        fstream f(Pfad.mb_str(wxConvUTF8), ios::out);
        f << Feld1->GetLineText(0).mb_str(wxConvUTF8) << endl;
        f << Feld2->GetLineText(0).mb_str(wxConvUTF8) << endl;
        f << Feld3->GetLineText(0).mb_str(wxConvUTF8) << endl;

        wxMessageBox(_("Die Synchronisationsdatei \nwurde erfolgreich abgespeichert"),
                     _("Abspeichern erfolgreich"));
        return true;
        // Gibt zurück, dass Datei gespeichert wurde
    }
    wxMessageBox(_("Synchronisationsdatei konnte nicht\nabgespeichert werden"),
                 _("Unbekannter Fehler"),
                 wxOK | wxICON_ERROR);
    return false;
    // Gibt zurück, dass Datei nicht gespeichert wurde
}

/* Die Daten aus der ausgewählten otto-Datei
** werden in das Fenster eingetragen
*/
void Auswahl::DatenSchreiben()
{
    string Buf;
    fstream Datei(Pfadbuf.c_str(), ios::in);
    getline(Datei, Buf);
    Feld1->WriteText(wxString::FromUTF8(Buf.c_str()));
    getline(Datei, Buf);
    Feld2->WriteText(wxString::FromUTF8(Buf.c_str()));
    getline(Datei, Buf);
    Feld3->WriteText(wxString::FromUTF8(Buf.c_str()));
}
