#include "Konstanten.h"

BEGIN_EVENT_TABLE(Hauptfenster, wxFrame)
    EVT_MENU(ID_Ueber_mich, Hauptfenster::Ueber_mich)
    EVT_MENU(ID_Version, Hauptfenster::Version)
    EVT_MENU(ID_Entwicklerseite, Hauptfenster::Entwicklerseite)
    EVT_MENU(ID_Textverschluesselung, Hauptfenster::Textverschluesselung)
    EVT_MENU(ID_Ende, Hauptfenster::Ende)
    EVT_MENU(ID_Erstellen, Hauptfenster::Erstellen)
    EVT_MENU(ID_Aendern, Hauptfenster::Aendern)
    EVT_MENU(ID_Einstellungen, Hauptfenster::Einstellung)

    EVT_BUTTON(ID_Synchronisieren_NachWahl, Hauptfenster::Synchronisieren_NachWahl)
    EVT_BUTTON(ID_Synchronisieren_Eigene, Hauptfenster::Synchronisieren_Eigene)
    EVT_BUTTON(ID_AktuelleVersion, Hauptfenster::AktuelleVersion)
    EVT_BUTTON(ID_Ende, Hauptfenster::Ende)
END_EVENT_TABLE()

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{
    // Kontrolle, ob das Programm aktuell ist
    wxHTTP http;

    // Wenn Verbindung aufgebaut werden kann
    if(http.Connect(_("otto-aus-mainz.de")))
    {
        wxInputStream *Stream = http.GetInputStream(_("http://otto-aus-mainz.de/nils/synchronisieren.html"));
        wxString res;
        wxStringOutputStream out_stream(&res);

        Stream->Read(out_stream);

        // Wenn nicht aktuell
        if(res.Mid(15, 8)!=_("18.01.13"))
        {
            int Antw = wxMessageBox(_("Neue Version herunterladen?"),
                                    _("Programm nicht mehr aktuell"),
                                    wxYES_NO | wxICON_QUESTION);
            if(Antw==wxYES)
            {
                wxLaunchDefaultBrowser(_("http://otto-aus-mainz.de/nils/Synchronisieren.html"));
                return false;
            }
        }
    }

    Hauptfenster *frame = new Hauptfenster();
    SetTopWindow(frame);
    frame->Show(true);
    return true;
}

Hauptfenster::Hauptfenster()
    : wxFrame(NULL, 0, _("Synchronisationsprogramm"), wxPoint(60, 50), wxSize(450, 340))
{
    wxMenu *Menue_Klick_Mich = new wxMenu;
    wxMenu *Menue_Aktionen = new wxMenu;
    wxMenu *Menue_Bearbeiten = new wxMenu;
    wxMenu *Menue_Programme = new wxMenu;

    Menue_Programme->Append( ID_Entwicklerseite, _("&Entwicklerseite..."));
    Menue_Programme->AppendSeparator();
    Menue_Programme->Append( ID_Textverschluesselung, _("&Textverschlüsselung..."));

    Menue_Klick_Mich->Append( ID_Ueber_mich, _("&Über mich...") );
    Menue_Klick_Mich->AppendSeparator();
    Menue_Klick_Mich->Append( ID_Version, _("&Programmversion..."));
    Menue_Klick_Mich->AppendSubMenu(Menue_Programme, _("Weitere Programme"));
    Menue_Klick_Mich->AppendSeparator();
    Menue_Klick_Mich->Append( ID_Ende, _("&Ende\tDEL") );

    Menue_Aktionen->Append( ID_Erstellen, _("&Erstellen..."));
    Menue_Aktionen->Append( ID_Aendern, _("&Ändern..."));

    Menue_Bearbeiten->Append( ID_Einstellungen, _("&Einstellungen..."));

    wxMenuBar *Menue = new wxMenuBar;

    Menue->Append( Menue_Klick_Mich, _("&Klick mich!") );
    Menue->Append( Menue_Aktionen, _("&Datei") );
    Menue->Append( Menue_Bearbeiten, _("&Bearbeiten"));

    SetMenuBar( Menue );

    wxPanel *Panel = new wxPanel(this);
    Panel->SetBackgroundColour(wxColour(100, 0, 255));

    wxStaticText *TextSync = new wxStaticText(Panel, wxID_ANY, _("Synchronisieren"),
            wxPoint(20, 20));
    TextSync->Show(true);

    wxButton *NachWahl = new wxButton(Panel, ID_Synchronisieren_NachWahl,
                                      _("Nach Wahl"), wxPoint(20, 50));
    NachWahl->Show(true);

    wxButton *Eigene = new wxButton(Panel, ID_Synchronisieren_Eigene,
                                    _("Eigene"), wxPoint(20, 90));
    Eigene->Show(true);

    wxStaticText *TextSeite = new wxStaticText(Panel, wxID_ANY, _("Entwicklerseite"),
            wxPoint(255, 20));
    TextSeite->Show(true);

    wxButton *AktuelleVersion = new wxButton(Panel, ID_AktuelleVersion,
            _("Aktuelle Version"), wxPoint(255, 50));
    AktuelleVersion->Show(true);

    wxButton *Ende = new wxButton(Panel, ID_Ende, _("Ende"), wxPoint(20, 230));
    Ende->Show(true);

    CreateStatusBar(1);
    SetStatusText(_("Ein Programm von Nils Otto"));
}

void Hauptfenster::Ueber_mich(wxCommandEvent& WXUNUSED(event))
{
    wxMessageBox( _("Ist der Größte"),
                  _("Nils Otto"),
                  wxOK | wxICON_INFORMATION, this);
}

void Hauptfenster::Version(wxCommandEvent& WXUNUSED(event))
{
    wxMessageBox( _("Vom 18.01.13.2012"),
                 _("Programmversion"),
                 0, this);
}

void Hauptfenster::Entwicklerseite(wxCommandEvent& WXUNUSED(event))
{
    wxLaunchDefaultBrowser(_("http://otto-aus-mainz.de/nils.html"));
}

void Hauptfenster::Textverschluesselung(wxCommandEvent& WXUNUSED(event))
{
    wxLaunchDefaultBrowser(_("http://otto-aus-mainz.de/nils/verschluesseln.html"));
}

void Hauptfenster::Ende(wxCommandEvent& WXUNUSED(event))
{
    Close(true);
}

void Hauptfenster::Erstellen(wxCommandEvent& WXUNUSED(event))
{
    Auswahl *frame = new Auswahl(A_Erstellen, _("Synchronisation erstellen"));
    frame->Show(true);
}

void Hauptfenster::Aendern(wxCommandEvent& WXUNUSED(event))
{
    string s;
    Auswahl *frame;
    const wxString& Pfad = wxFileSelector(_("Welche Datei soll bearbeitet werden?"),
                                          wxString::FromUTF8(Einst_Para(1).c_str()),
                                          NULL, NULL, _("*.otto"));
    if(!Pfad.empty())
    {
        frame = new Auswahl(A_Aendern, _("Synchronisationdatei ändern"), Pfad);
        frame->Show(true);
    }
}

void Hauptfenster::Einstellung(wxCommandEvent& WXUNUSED(event))
{
#ifdef __LINUX__
    mkdir(Einst_Verzeichnis.c_str(), 0777);
#else
    mkdir(Einst_Verzeichnis.c_str());
#endif
    Einstellungen *Fenster = new Einstellungen();
    Fenster->Show(true);
}

void Hauptfenster::Synchronisieren_NachWahl(wxCommandEvent& WXUNUSED(event))
{
    Auswahl *frame = new Auswahl(A_NachWahl, _("Synchronisation nach Wahl"));
    frame->Show(true);
}

void Hauptfenster::Synchronisieren_Eigene(wxCommandEvent& WXUNUSED(event))
{
    string s;
    Auswahl *frame;
    const wxString& Pfad = wxFileSelector(_("Welche Datei soll geöffnet werden?"),
                                          wxString::FromUTF8(Einst_Para(1).c_str()),
                                          NULL, NULL, _("*.otto"));
    if(!Pfad.empty())
    {
        frame = new Auswahl(A_Eigene, _("Synchronisationdatei ändern"), Pfad);
        frame->Show(true);
    }
}

void Hauptfenster::AktuelleVersion(wxCommandEvent& WXUNUSED(event))
{
    wxLaunchDefaultBrowser(_("http://otto-aus-mainz.de/nils/Synchronisieren.html"));
}
