#include "Konstanten.h"
#include "wx/dir.h"

#include <stdio.h>

using namespace std;

fstream f;

BEGIN_EVENT_TABLE(Statusanzeige, wxProgressDialog)

END_EVENT_TABLE()

Statusanzeige::Statusanzeige(double groesse)
    : wxProgressDialog(_("Synchronisationsfortschritt"), _("1. Ordner"), 1000, NULL,
                       wxPD_REMAINING_TIME | wxPD_AUTO_HIDE | wxPD_CAN_ABORT)
{
    Status = 0;
    Groesse = groesse;
    Ordner2 = 0;
    SyncErfolg = true;
}

Statusanzeige::~Statusanzeige()
{
    f << endl << endl << endl;
    if(SyncErfolg)
    {
        f << "Die Synchronisation wurde erfolgreich beendet.";
        wxMessageBox(_("Synchronisation erfolgreich"),
                     _("Die Synchronisation wurde erfolgreich beendet"));
    }
    else
    {
        f << "Die Synchronisation wurde abgebrochen";
        wxMessageBox(_("Die Synchronisation wurde abgebrochen,\nkann aber fortgesetzt werden"),
                     _("Abbruch"),
                     wxICON_ERROR, this);
    }
    f.close();
}

bool Statusanzeige::Addiere(double d)
{
    Status += d;
    if(Update(Status*500/Groesse+Ordner2))
        return true;
    else
    {
        SyncErfolg = false;
        return false;
    }
}

void Statusanzeige::SetGroesse(double d)
{
    Groesse = d;
    Ordner2 = 500;
    Status = 0;
    Pulse(_("2. Ordner"));
}

bool Statusanzeige::GetSyncErfolg()
{
    return SyncErfolg;
}

void StreichWeg(char *charZeiger)
{
    for(unsigned int a=string(charZeiger).rfind(Abtrenner); charZeiger[a]; charZeiger++)
        charZeiger[a] = 0; // Trenne hier den Pfad bis zum Abtrenner ab
}

void FuegeHinzu(char *charZeiger, const char Datei[512])
{
    while(*charZeiger) // Gehe mit dieser Schleife ans Ende der Eingabe
        charZeiger++;
    *charZeiger = Abtrenner; // Der Abtrenner wird angehängt
    charZeiger++;
    while(*Datei)
    {
        *charZeiger = *Datei;
        charZeiger++;
        Datei++;
    }
}

void KopiereDatei(const char cEing[512], const char cAusg[512])
{
    string sAusg_Teil = string(cAusg); // Mache einen4 String zur Ausg, zur besseren Bearbeitung
    sAusg_Teil+=".otto_teil"; // .otto_teil anhängen, damit die Datei nicht direkt überschrieben wird
    ifstream Eing(cEing, ios::binary); // Deklariere Eingabedatei
    ofstream Ausg(sAusg_Teil.c_str(), ios::binary); // und Ausgabedatei
    const int Groesse = 768; // Größe der Kopierblöcke
    char Buffer[Groesse] = {0};
    if(Eing.good() && Ausg.good()) // Abfrage, ob die Eingabe und Ausgabe-Dateiein in Ordnung sind
    {
        while(!Eing.eof()) // Kopiere, solange Datei noch nicht am Ende
        {
            Eing.read(Buffer, Groesse); // Lesen des Blocks
            Ausg.write(Buffer, Eing.gcount()); // Schreiben des Blocks bis zum Ende
        }
        Eing.close(); // Müssen hier geschlossen werden,
        Ausg.close(); // Sonst funktioniert rename() nicht
    }
    rename(sAusg_Teil.c_str(), cAusg);
    f << endl << endl;
}

void Kopiere(char cEing[512], char cAusg[512], Statusanzeige *Status)
{
    struct stat Eigenschaft; // Deklaration der Struktur stat, die Eigenschaften einer Datei beinhaltet
    stat(cEing, &Eigenschaft); // Schreibe die Dateieigenschaften in "Eigenschaft"
    if(Eigenschaft.st_mode & S_IFDIR) // Verzeichnis
    {
        if(rmdir(cEing)) // Wird nicht gelöscht -> enthält Dateien/Ordner
        {
#ifdef __LINUX__
            mkdir(cAusg, 0777);
#else
            mkdir(cAusg);
#endif
            bool b = false;
            DIR *DIR = opendir(cEing); // Öffne zuerst Pfad und schreibe es in den Zeiger "DIR"
            dirent *Dirent; // Deklaration Dirent, in den die Dateieinamen geschrieben werden
            while((Dirent = readdir(DIR))) // Frage readdir() ab, um das Verzeichnis nach Ordnern und Dateien
            {                               // zu durchsuchen und schreibe es in Dirent

                if(ZuKopieren(Dirent->d_name, cEing)) // Kontrolle, ob Kopiert werden soll
                {
                    if(b) // Damit es beim ersten Mal nicht gemacht wird!!!
                    {
                        StreichWeg(cEing);
                        StreichWeg(cAusg);
                    }
                    b = true; // Jetzt ist b wahr, damit es beim nächsten Mal gemacht wird
                    FuegeHinzu(cEing, Dirent->d_name);
                    FuegeHinzu(cAusg, Dirent->d_name);
                    Kopiere(cEing, cAusg, Status); // Gehe ins nächstuntere Verzeichnis
                }
            }
            StreichWeg(cEing);
            StreichWeg(cAusg);
        }
        else
        {
/* Der Ordner wird in cEing wieder erstellt
** da er gelöscht wurde, cAusg wird auch erstellt
*/
#ifdef __LINUX__
            mkdir(cEing, 0777);
            mkdir(cAusg, 0777);
#else
            mkdir(cEing);
            mkdir(cAusg);
#endif
        }
    }
    else // Falls Datei
    {
        struct stat EigenschaftEing, EigenschaftAusg;
        stat(cEing, &EigenschaftEing);
        stat(cAusg, &EigenschaftAusg);
        if(Status->Addiere(EigenschaftEing.st_size))
        {
            // cEing wird nach cAusg kopiert, wenn cAusg nicht existiert
            if(!wxFileExists(wxString::FromUTF8(cAusg)))
            {
                f << "Kopiere *" << cEing << "*" << endl << "   nach *" << cAusg << "*";
                KopiereDatei(cEing, cAusg);
            }
            // cAusg wird ersetzt, wenn die Datei älter ist
            else if(IstAelter(cEing, cAusg))
            {
                f << "Kopiere *" << cEing << "*" << endl << "ersetze *" << cAusg << "*";
                KopiereDatei(cEing, cAusg);
            }
        }
    }
}

bool Synchronisation(char cEing[512], char cAusg[512], char Textdokument[512])
{
    bool Erfolg = false;
    // Ein Ordner nicht vorhanden -> Abbruch
    if(!wxDirExists(wxString::FromUTF8(cEing)) || !wxDirExists(wxString::FromUTF8(cAusg)))
    {
        wxMessageBox(_("Einer der Ordner ist nicht vorhanden"),
                     _("Synchronisation nicht möglich"),
                     wxOK | wxICON_ERROR, NULL);
    }
    else
    {
        // Ordner können geöffnet werden
        int Antw=wxYES;
        // Abfrage, wenn Textdokument leer ist
        if(string(Textdokument).length()==0)
        {
            // Falls Keine Doku-Datei ausgewählt
            Antw = wxMessageBox(_("Synchronisation wirklich ohne\nDokumentation starten?"),
                                _("Keine Dokumentationsdatei"),
                                wxYES_NO | wxICON_QUESTION);
        }
        /* Füge dem Pfad des Textdokumentes noch den
        ** Dateinamen hinzu
        */
        FuegeHinzu(Textdokument, "Sync_Doku.txt");
        if(Antw==wxYES)
        {
            Antw = wxMessageBox(wxString::FromUTF8(cEing) + _("\n") + wxString::FromUTF8(cAusg),
                                _("Synchronisation der Ordner"),
                                wxYES_NO | wxICON_QUESTION);
            if(Antw==wxYES)
            {
                double d = wxDir::GetTotalSize(wxString::FromUTF8(cEing)).GetValue();
                Statusanzeige *Status = new Statusanzeige(d);

                f.open(Textdokument, ios::out);
                DokuKopf(cEing, cAusg); // Schreibe die Daten in die Doku

                Kopiere(cEing, cAusg, Status); // Vergleiche

                // Wenn nicht abgebrochen wurde
                if(Status->GetSyncErfolg())
                {
                    d = wxDir::GetTotalSize(wxString::FromUTF8(cAusg)).GetValue();
                    Status->SetGroesse(d); // Neue Groesse für den 2. Ordner
                    Kopiere(cAusg, cEing, Status); // Damit auch andersherum kopiert wird
                    Erfolg = Status->GetSyncErfolg();
                }
                Status->Destroy();
            }
        }
    }
    return Erfolg;
}

// Schreibt den "Kopf" in die
// Dokumentation
inline void DokuKopf(const char cEing[512], const char cAusg[512])
{
    time_t Zeitstempel;
    tm *nun;
    Zeitstempel = time(0);
    nun = localtime(&Zeitstempel);
    f << "Synchronisation: " << nun->tm_year+1900;
    f << "-" << nun->tm_mon+1;
    f << "-" << nun->tm_mday;
    f << "  " << nun->tm_hour;
    f << ":" << nun->tm_min;
    f << ":" << nun->tm_sec << endl;
    f << endl << cEing << " <> " << cAusg << endl << endl;
}

// Gibt wahr zurück, wenn cAusg älter als cEing ist
bool IstAelter(const char cEing[512], const char cAusg[512])
{
    struct stat eEing, eAusg;
    stat(cEing, &eEing);
    stat(cAusg, &eAusg);
    if((difftime(eEing.st_atime, eAusg.st_atime) > 0
        && eEing.st_size!=eAusg.st_size))
        return true;
    return false;
}

/* Gibt zurück, ob Datei kopiert werden soll
** Ausnahmen kann es z.B. geben, wenn Dateien
** Als gelöscht deklariert sind, aber noch nicht
** wirklich sind, sodass sie mit einem ~
** am Dateiende auftauchen.
*/
bool ZuKopieren(const char cName[256], const char cEing[512])
{
    char c[512] = {0};
    string Name = string(cName);
    string letzten10;

    /* in c wird cEing geschrieben und dann der Dateiname durch
    ** cName ersetzt, damit c das neue Verzeichnis ist
    */
    strcpy(c, cEing);
    StreichWeg(c);
    FuegeHinzu(c, cName);

    /* Schreibt die letzten 10 Buchstaben von Name
    ** in letzten9, um es auf ".otto_teil" zu
    ** kontrollieren
    */
    for(unsigned int i=Name.length()-10; i<Name.length(); i++)
        letzten10+=Name[i];

    //Dieser komische Punkt soll nicht kommen
    if(Name[0]=='.' && Name.length()==1)
             return false;

    // Diese komischen 2 Punkte sollen nicht kommen
    else if(Name[0]=='.' && Name[1]=='.' && Name.length()==2)
            return false;

    // Das sind schon als gelöscht deklarierte Dateien
    else if(Name[Name.length()-1]=='~')
            return false;

    /* Eine otto_teil Datei darf nicht kopiert werden,
    ** da sie wohl aus einem Absturz des Programms
    ** resultiert. Deshalb wird sie gleich gelöscht
    */
    else if(letzten10==".otto_teil")
    {
        remove(c);
        return false;
    }

    // Gib ansonsten true zurück
    return true;
}
